local width = love.graphics.getWidth()
local height = love.graphics.getHeight()
local gravity = 9,81
function cteateplayer()
	local tab = {}
	tab.x = width/2
	tab.y = height/2
	tab.speed = 150
	return tab
end

function createbullet(x,y,sx,sy,yd,id)
	local tab = {}
	tab.x = x
  	tab.y = y
	tab.mass = 10
	tab.radius = 10
	tab.time = 0
	tab.lifetime = 0
  	tab.speedx = sx
	tab.speedy0 = sy 
  	tab.speedy = sy 
	tab.ydistance = yd
	tab.id = id
	return tab
end

function love.load()
  	player = cteateplayer()
	allbullets = {}
end
bulln = 0

function love.update(dt)
	if love.keyboard.isDown("up") then
		player.y = player.y - player.speed*dt
	end
	if love.keyboard.isDown("down") then
		player.y = player.y + player.speed*dt
	end
	if love.keyboard.isDown("left") then
		player.x = player.x - player.speed*dt
	end
	if love.keyboard.isDown("right") then
		player.x = player.x + player.speed*dt
	end
	bulln = 0
	for i,bullet in pairs(allbullets) do
		bullet.time = bullet.time + dt
		bullet.lifetime = bullet.lifetime + dt
		bullet.speedy = bullet.speedy0 - 100*gravity*bullet.time
		bullet.x = bullet.x  - bullet.speedx*dt
		bullet.y = bullet.y  - bullet.speedy*dt
		if bullet.x - bullet.radius <= 0 and bullet.speedx >= 0 then 
			bullet.speedx = 0 - bullet.speedx 
			bullet.x = bullet.speedx*dt/2 + bullet.radius
		end
		if bullet.x + bullet.radius >= width and bullet.speedx <= 0 then
			bullet.speedx = 0 - bullet.speedx 
			bullet.x = width - bullet.speedx*dt/2 - bullet.radius
		end
		if bullet.y + bullet.radius >= height and bullet.speedy < 0 then 
			bullet.speedy = 0 - bullet.speedy 
			bullet.speedy0 = bullet.speedy
			bullet.time = 0
			bullet.y = height - bullet.speedy*dt/2 - bullet.radius
		end
		for j,coll in pairs(allbullets) do
			if not (bullet.id == coll.id) then
				local distance = ((bullet.x-coll.x)^2+(bullet.y-coll.y)^2)^0.5
				if distance <= 2*bullet.radius then
					if bullet.x >= coll.x and bullet.speedx >= 0 then
						bullet.speedx,coll.speedx = 0-coll.speedx,bullet.speedx
						bullet.x = bullet.x + bullet.speedx*dt
					elseif bullet.x < coll.x and bullet.speedx <= 0 then
						bullet.speedx,coll.speedx = 0-coll.speedx,bullet.speedx
						bullet.x = bullet.x - bullet.speedx*dt
					end
					if bullet.y >= coll.y and bullet.speedy >= 0 then
						bullet.speedy,coll.speedy = 0-coll.speedy,bullet.speedy 
						bullet.speedy0 = bullet.speedy
						bullet.time = 0
						coll.speedy0 = coll.speedy
						coll.time = 0
						bullet.y = bullet.y + bullet.speedy*dt
					elseif bullet.y < coll.y and bullet.speedy <= 0 then
						bullet.speedy,coll.speedy = 0-coll.speedy,bullet.speedy 
						bullet.speedy0 = bullet.speedy
						bullet.time = 0
						coll.speedy0 = coll.speedy
						coll.time = 0
						bullet.y = bullet.y - bullet.speedy*dt
					end
					break
				end
			end
		end
		if bullet.lifetime > 60 then allbullets[i] = nil end
		bulln = bulln + 1
	end

end
local j = 1
function love.mousepressed( x, y, button )
	if button == "l" then
		local play = ((player.y-y)*(player.y-y))^0.5
		local play2 = 10*(play*2*gravity)^0.5
		if (player.y-y) < 0 then play2= 0 - play2 end
		--local distance = ((player.x-x)^2+(player.y-y)^2)^0.5
		allbullets[j] = createbullet(player.x,player.y,2*(player.x-x),play2,player.y-y,j) 
		j = j+1
		if j >500 then j = 0 end
	end
end

function love.draw()
	love.graphics.setColor(0,0,210)
   	love.graphics.circle("fill",player.x,player.y,10)
	love.graphics.print(love.timer.getFPS().."   "..bulln,player.x+10,player.y)
	love.graphics.setColor(255,255,255)
	for i,bullet in pairs(allbullets) do
		love.graphics.circle("fill",bullet.x,bullet.y,bullet.radius)
		love.graphics.print(math.floor(bullet.lifetime),bullet.x+10,bullet.y)
		--love.graphics.line( player.x,player.y, bullet.x,bullet.y)
	end
end
